



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>POJ 1655 Balancing Act 树的重心</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">POJ 1655 Balancing Act 树的重心</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-20 03:33:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div><strong>Balancing Act</strong></div>
<div>&nbsp;</div>
<p><strong>Description</strong></p>
<div>Consider a tree T with N (1 &lt;= N &lt;= 20,000) nodes numbered 1...N. Deleting any node from the tree yields a forest: a collection of one or more trees. Define the balance of a node to be the size of the largest tree in the forest T created by deleting that node from T.&nbsp;<br />For example, consider the tree:&nbsp;<br /><img referrerpolicy="no-referrer"src="http://poj.org/images/1655_1.jpg" /><br />Deleting node 4 yields two trees whose member nodes are {5} and {1,2,3,6,7}. The larger of these two trees has five nodes, thus the balance of node 4 is five. Deleting node 1 yields a forest of three trees of equal size: {2,6}, {3,7}, and {4,5}. Each of these trees has two nodes, so the balance of node 1 is two.</p>
<p>For each input tree, calculate the node that has the minimum balance. If multiple nodes have equal balance, output the one with the lowest number.</p></div>
<p><strong>Input</strong></p>
<div>The first line of input contains a single integer t (1 &lt;= t &lt;= 20), the number of test cases. The first line of each test case contains an integer N (1 &lt;= N &lt;= 20,000), the number of congruence. The next N-1 lines each contains two space-separated node numbers that are the endpoints of an edge in the tree. No edge will be listed twice, and all edges will be listed.</div>
<div>&nbsp;</div>
<p><strong>Output</strong></p>
<div>For each test case, print a line containing two integers, the number of the node with minimum balance and the balance of that node.</div>
<div>&nbsp;</div>
<p><strong>Sample Input</strong></p>
<pre class="prettyprint linenums">1<br />
7<br />
2 6<br />
1 2<br />
1 4<br />
4 5<br />
3 7<br />
3 1
</pre>
<p><strong>Sample Output</strong></p>
<pre class="prettyprint linenums">1 2</pre>
<p><strong>题意：</strong></p>
<p>　　给你n点的树</p>
<p>　　让你删去一个点，剩下的 子树中节点数最多的就是删除这个点的 价值</p>
<p>　　求删除哪个点 价值最小就是重心　</p>
<p><strong>题解：</strong></p>
<p>　　来来来</p>
<p>　　认识一下什么重心</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;cmath&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;vector&gt;<br />
#include &lt;algorithm&gt;<br />
using namespace std;<br />
const int N = 1e5+, M = 1e2+, mod = 1e9+, inf = 1e9+;<br />
typedef long long ll;

vector&lt;int &gt; G[N];<br />
int T,n,siz[N],mx,mx1;<br />
void dfs(int u,int fa) {<br />
    siz[u] = ;<br />
    int ret = ;<br />
    for(int i=;i&lt;G[u].size();i++) {<br />
        int to = G[u][i];<br />
        if(to == fa) continue;<br />
        dfs(to,u);<br />
        siz[u] += siz[to];<br />
        ret = max(ret , siz[to]);<br />
    }<br />
    if(u!=) ret = max(ret , n - siz[u]);<br />
    if(ret &lt;= mx) {<br />
        mx1 = u;<br />
        mx = ret;<br />
    }<br />
}<br />
int main()<br />
{<br />
    scanf("%d",&amp;T);<br />
    while(T--) {<br />
        scanf("%d",&amp;n);<br />
        for(int i=;i&lt;N;i++) G[i].clear();<br />
        for(int i=;i&lt;n;i++) {<br />
            int a,b;<br />
            scanf("%d%d",&amp;a,&amp;b);<br />
            G[a].push_back(b);<br />
            G[b].push_back(a);<br />
        }<br />
        mx = inf;<br />
        dfs(,-);<br />
        printf("%d %d\n",mx1 , mx);<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1nd29g.html">VS 2015相当不错的功能：C&num;交互窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pmwpz9.html">CentOS个人目录下中文路径转英文路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8er62zq.html">Scalaz（18）－ Monad： ReaderWriterState-可以是一种简单的编程语言</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnek2jq.html">三维高斯模型 opencv实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/m966wjv9.html">iOS腾讯百度面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0j5eeq.html">android 介绍0</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1r6wd9.html">Linux配置静态IP</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w2yv3q.html">javascript加速运动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnykre8.html">面试题 IQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1d2x39.html">oracle拼接字段用&vert;&vert;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok22le9.html">40个Java集合面试问题和答案【上】【转载】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjl2kk8.html">startup alter&period;log spfile&period;ora</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpxw5j9.html">从零开始学深度学习mxnet教程：安装以及基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj6o0k8.html">JAVA多线程-实现通讯</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5y03eq.html">&sol;etc&sol;fstab 文件挂载配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wnwwgq.html">关于centos7和centos6中平滑升级nginx到新版本v1&period;12&period;1修复nginx最新漏洞CVE-2017-7529的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2r26x9.html">json信息的后台到前台的传输</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvr6r38.html">python正则表达式贪婪与非贪婪模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/902p3moq.html">swift  VFL - 父视图是scrollview 注意点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjonro8.html">unity&comma; 设置帧率上限</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93l1409.html">POJ 1308</a>
			</li>
						<li><a href="https://www.batexi.com/a/390ngomq.html">Windows 下的 MarkdownPad 2 工具使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r3v0m9.html">Mathematics&colon;Dead Fraction&lpar;POJ 1930&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r3o3r9.html">会话控制（session、cookie）</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r3o2e9.html">php简易灌水</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxjwde9.html">Redis基础命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2ewwvq.html">关于HTML5在动画制作工具Animatron的一些问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7vmmkq.html">根据复选框checkbox的选中状态来打开或关闭隐藏层</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvpvkxq.html">maximum subarray problem</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwpdxl8.html">求sqrt&lpar;&rpar;底层效率问题（二分&sol;牛顿迭代）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
